#include "common.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>

#ifdef __cplusplus
extern "C" {
#endif

int
LLVMFuzzerTestOneInput(const uint8_t *data, size_t size) {
    size_t i = 0;

    uint8_t uint8_eq_const_0_0;
    uint16_t uint16_eq_const_1_0;
    uint64_t uint64_eq_const_2_0;
    uint16_t uint16_eq_const_3_0;
    uint16_t uint16_eq_const_4_0;
    uint64_t uint64_eq_const_5_0;
    uint8_t uint8_eq_const_6_0;
    uint64_t uint64_eq_const_7_0;
    uint64_t uint64_eq_const_8_0;
    uint16_t uint16_eq_const_9_0;
    uint16_t uint16_eq_const_10_0;
    uint32_t uint32_eq_const_11_0;
    uint64_t uint64_eq_const_12_0;
    uint8_t uint8_eq_const_13_0;
    uint32_t uint32_eq_const_14_0;
    uint16_t uint16_eq_const_15_0;

    if (size < 63)
        return TEPHRA_EXIT_FAILURE;


    memcpy(&uint8_eq_const_0_0, &data[i], 1);
    i += 1;
    memcpy(&uint16_eq_const_1_0, &data[i], 2);
    i += 2;
    memcpy(&uint64_eq_const_2_0, &data[i], 8);
    i += 8;
    memcpy(&uint16_eq_const_3_0, &data[i], 2);
    i += 2;
    memcpy(&uint16_eq_const_4_0, &data[i], 2);
    i += 2;
    memcpy(&uint64_eq_const_5_0, &data[i], 8);
    i += 8;
    memcpy(&uint8_eq_const_6_0, &data[i], 1);
    i += 1;
    memcpy(&uint64_eq_const_7_0, &data[i], 8);
    i += 8;
    memcpy(&uint64_eq_const_8_0, &data[i], 8);
    i += 8;
    memcpy(&uint16_eq_const_9_0, &data[i], 2);
    i += 2;
    memcpy(&uint16_eq_const_10_0, &data[i], 2);
    i += 2;
    memcpy(&uint32_eq_const_11_0, &data[i], 4);
    i += 4;
    memcpy(&uint64_eq_const_12_0, &data[i], 8);
    i += 8;
    memcpy(&uint8_eq_const_13_0, &data[i], 1);
    i += 1;
    memcpy(&uint32_eq_const_14_0, &data[i], 4);
    i += 4;
    memcpy(&uint16_eq_const_15_0, &data[i], 2);
    i += 2;


    if (uint8_eq_const_0_0 == 146)
    if (uint16_eq_const_1_0 == 22416)
    if (uint64_eq_const_2_0 == 2319257308722474128u)
    if (uint16_eq_const_3_0 == 43423)
    if (uint16_eq_const_4_0 == 59731)
    if (uint64_eq_const_5_0 == 9653731749787767937u)
    if (uint8_eq_const_6_0 == 83)
    if (uint64_eq_const_7_0 == 11947190758728839513u)
    if (uint64_eq_const_8_0 == 3293321162987805734u)
    if (uint16_eq_const_9_0 == 47920)
    if (uint16_eq_const_10_0 == 9077)
    if (uint32_eq_const_11_0 == 4053792095)
    if (uint64_eq_const_12_0 == 8911675234667584916u)
    if (uint8_eq_const_13_0 == 187)
    if (uint32_eq_const_14_0 == 2490985961)
    if (uint16_eq_const_15_0 == 3458)
        BOOM();

    return TEPHRA_EXIT_SUCCESS;
}

#ifdef __cplusplus
}
#endif
